# vim: set sw=4 ts=4 et:
# Copyright (c) 2005-2010 oc2pus
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments to toni@links2linux.de

Name:           mixxx
Summary:        Open source DJ tool
Version:        1.7.2
Release:        0.pm.2.24
License:        GPL
Group:          Productivity/Multimedia/Sound/Players
URL:            http://mixxx.sourceforge.net/
# http://downloads.mixxx.org/mixxx-%{version}/mixxx-%{version}-src.tar.gz
Source0:        mixxx-%{version}-src.tar.bz2
Patch0:         %{name}-libdjconsole-check.patch
Patch1:         %{name}-libmp4v2.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
BuildRequires:  alsa-devel
BuildRequires:  audiofile-devel audiofile
BuildRequires:  bzr
BuildRequires:  fdupes
BuildRequires:  freeglut-devel
BuildRequires:  glib2-devel
BuildRequires:  ladspa
BuildRequires:  libdjconsole-devel
BuildRequires:  libfaad-devel
#BuildRequires:	libffmpeg0-devel
BuildRequires:  libgpod-devel
BuildRequires:  libid3tag-devel
BuildRequires:  libjack-devel >= 0.109
BuildRequires:  libmp3lame-devel
BuildRequires:  libmusicbrainz-devel
BuildRequires:  libsamplerate-devel
BuildRequires:  libshout-devel
BuildRequires:  libsndfile-devel
BuildRequires:  libusb-devel
BuildRequires:  libvorbis-devel
BuildRequires:  lua50-devel
BuildRequires:  mad-devel
BuildRequires:  pkgconfig
BuildRequires:  portaudio-devel
BuildRequires:  python-devel
BuildRequires:  qt-devel
BuildRequires:  scons
BuildRequires:  soundtouch-devel >= 1.3
BuildRequires:  tolua >= 5.0
#BuildRequires:	tolua-devel >= 5.0
BuildRequires:  update-desktop-files
BuildRequires:  zlib-devel
Requires:       alsa
Requires:       audiofile
Requires:       jack
Requires:       lua50 >= 5.0.2
Requires:       mad
Requires:       python
Requires:       soundtouch >= 1.3
Requires:       tolua >= 5.0

BuildRequires:  libspeex1

%description
Mixxx is designed for DJ'ing for both professional and
semi-professional users.
Mixxx was started in early 2001 as one of the first digital
DJ systems.

Today Mixxx includes many features common to digital DJ solutions,
but also some very unique features: It is free, and runs on all
major desktop operating systems.

Furthermore Mixxx has a number of key features to help the DJ in
the live mix: Beat estimation, parallel visual displays, and
support for many DJ input controllers.

Mixxx is software for DJ'ing. You can use wave based audio files,
Ogg Vorbis and MP3 files as audio input. Mixxx can be controlled
through the GUI and with external controllers including MIDI
devices, joysticks and more.

Author:         <tuehaste@users.sourceforge.net>

%package skin-hercules
Summary:        A skin for mixxx
Group:          Productivity/Multimedia/Sound/Players
Requires:       %{name} = %{version}

%description skin-hercules
A skin for package mixxx.

%package skin-outlineClose
Summary:        A skin for mixxx
Group:          Productivity/Multimedia/Sound/Players
Requires:       %{name} = %{version}

%description skin-outlineClose
A skin for package mixxx.

%package skin-outline
Summary:        A skin for mixxx
Group:          Productivity/Multimedia/Sound/Players
Requires:       %{name} = %{version}

%description skin-outline
A skin for package mixxx.

%package skin-outlineMini
Summary:        A skin for mixxx
Group:          Productivity/Multimedia/Sound/Players
Requires:       %{name} = %{version}

%description skin-outlineMini
A skin for package mixxx.

%package skin-outlineNetbook
Summary:        A skin for mixxx
Group:          Productivity/Multimedia/Sound/Players
Requires:       %{name} = %{version}

%description skin-outlineNetbook
A skin for package mixxx.

%package skin-nCut
Summary:        A skin for mixxx
Group:          Productivity/Multimedia/Sound/Players
Requires:       %{name} = %{version}

%description skin-nCut
A skin for package mixxx.

%package skin-Collusion
Summary:        A skin for mixxx
Group:          Productivity/Multimedia/Sound/Players
Requires:       %{name} = %{version}

%description skin-Collusion
A skin for package mixxx.

%package skin-traditional
Summary:        A skin for mixxx
Group:          Productivity/Multimedia/Sound/Players
Requires:       %{name} = %{version}

%description skin-traditional
A skin for package mixxx.



%prep
%setup -q -n %{name}-%{version}
%patch0
%patch1
%{?suse_update_config:%{suse_update_config -f}}

%fdupes -s res/skins

# disable rpath
%__sed -i -e 's|-Wl,-rpath,\$QTDIR/lib||g' \
    src/SConscript

# dirty hack for faad2 ...
%__sed -i -e 's|uint32_t|unsigned long|g' \
    src/m4a/mp4-mixxx.cpp

%build
%if 0
djconsole: Set to 1 to enable Hercules support through libdjconsole
djconsole_legacy: Set to 1 to enable legacy Hercules support (for Hercules MP3 Control only, not MK2
hifieq: Set to 1 to enable high quality EQs
ipod: Set to 1 to enable iPod support through libgpod
ladspa: (EXPERIMENTAL) Set to 1 to enable LADSPA plugin support
ffmpeg: (EXPERIMENTAL) Set to 1 to enable FFMPEG support
vinylcontrol: Set to 1 to enable vinyl control support
shoutcast: Set to 1 to enable shoutcast support
cmetrics: Set to 1 to enable crash reporting/usage statistics via Case Metrics (This should be disabled on development builds)
optimize: Set to 1 to enable -O3 compiler optimizations. Set to 2 to enable Pentium 4 optimizations. Set to 3 to enable Intel Core optimizations, and set to 4 to enable Intel Core 2 optimizations.
script: Set to 1 to enable MixxxScript/QtScript Studio support.
midiscript: Set to 1 to enable MIDI Scripting support.
tonal: Set to 1 to enable tonal analysis
portmidi: Set to 1 to enable PortMidi unified MIDI backend
m4a: Set to 1 to enable support for M4A audio (Apple non-drmd music format)
qdebug: Set to 1 to enable verbose console debug output.
test: Set to 1 to build Mixxx test fixtures.
rawmidi: Set to 1 to use ALSA's RawMIDI API (instead of the Sequencer API.)
gprof: (DEVELOPER) Set to 1 to enable profiling using gprof
tuned: (EXPERIMENTAL) Set to 1 to optimise mixxx for this CPU
force32: Set to 1 to force GCC to compile a 32-bit binary with the -m32 flag
%endif
scons %{?jobs:-j%{jobs}} \
    prefix=%{_prefix} \
    djconsole=1 \
    djconsole_legacy=0 \
    hifieq=1 \
    experimentalrecord=1 \
    cmetrics=0 \
    ladspa=1 \
    vinylcontrol=1 \
    ffmpeg=0 \
    shoutcast=1 \
    ipod=1 \
    script=0 \
    midiscript=1 \
    tonal=1 \
    m4a=1 \
    portmidi=0

%install
%__install -dm 755 %{buildroot}%{_bindir}

scons %{?jobs:-j%{jobs}} \
    prefix=%{buildroot}%{_prefix} \
    djconsole=1 \
    djconsole_legacy=0 \
    hifieq=1 \
    experimentalrecord=1 \
    cmetrics=0 \
    ladspa=1 \
    vinylcontrol=1 \
    ffmpeg=0 \
    shoutcast=1 \
    ipod=1 \
    script=0 \
    midiscript=1 \
    tonal=1 \
    m4a=1 \
    portmidi=0 \
    install

# scons does a new link with -DUNIX_SHARE_PATH=%{buildroot}%{_prefix}/share/mixxx
# this leads to a broken binary, so overwrite it with the previous builded ... 
%__install -m 755 %{name} \
    %{buildroot}%{_bindir}

# Desktop file
%__rm -f src/%{name}.desktop
%__cat > %{buildroot}%{_datadir}/applications/%{name}.desktop << EOF
[Desktop Entry]
Name=Mixxx
GenericName=Mixxx
Comment=A digital DJ interface
Exec=%{name}
Icon=%{name}-icon
Terminal=false
Type=Application
EOF
%suse_update_desktop_file -i %{name} AudioVideo Player Jukebox

%__chmod 755 %{buildroot}%{_datadir}/%{name}/skins/outlineMini/shifter.sh
%__chmod 755 %{buildroot}%{_datadir}/%{name}/midi/convertToXMLSchemaV1.php
%__chmod 644 %{buildroot}%{_datadir}/%{name}/midi/Mixman*.js

%clean
%{?buildroot:%__rm -rf "%{buildroot}"}

%files
%defattr(-,root,root)
%doc COPYING LICENSE Mixxx-Manual.pdf README*
%{_bindir}/%{name}
%exclude %{_datadir}/%{name}/skins/hercules
%exclude %{_datadir}/%{name}/skins/nCut
%exclude %{_datadir}/%{name}/skins/outline
%exclude %{_datadir}/%{name}/skins/outlineClose
%exclude %{_datadir}/%{name}/skins/outlineMini
%exclude %{_datadir}/%{name}/skins/outlineNetbook
%exclude %{_datadir}/%{name}/skins/traditional
%exclude %{_datadir}/%{name}/skins/Collusion*
%dir %{_datadir}/%{name}
%dir %{_datadir}/%{name}/keyboard
%{_datadir}/%{name}/keyboard/*
%dir %{_datadir}/%{name}/ladspa_presets
%{_datadir}/%{name}/ladspa_presets/*
%dir %{_datadir}/%{name}/midi
%{_datadir}/%{name}/midi/*

%dir %{_datadir}/%{name}/skins
%{_datadir}/%{name}/skins/README.xsl
%{_datadir}/%{name}/skins/skin.xsl
%{_datadir}/%{name}/skins/cross.*
%dir %{_datadir}/%{name}/skins/outlineSmall
%{_datadir}/%{name}/skins/outlineSmall/*

%{_datadir}/pixmaps/%{name}*.png
%{_datadir}/applications/%{name}*.desktop

%files skin-hercules
%defattr(-,root,root)
%dir %{_datadir}/%{name}/skins/hercules
%{_datadir}/%{name}/skins/hercules/*

%files skin-outline
%defattr(-,root,root)
%dir %{_datadir}/%{name}/skins/outline
%{_datadir}/%{name}/skins/outline/*

%files skin-outlineClose
%defattr(-,root,root)
%dir %{_datadir}/%{name}/skins/outlineClose
%{_datadir}/%{name}/skins/outlineClose/*

%files skin-outlineMini
%defattr(-,root,root)
%dir %{_datadir}/%{name}/skins
%dir %{_datadir}/%{name}/skins/outlineMini
%{_datadir}/%{name}/skins/outlineMini/*

%files skin-outlineNetbook
%defattr(-,root,root)
%dir %{_datadir}/%{name}/skins
%dir %{_datadir}/%{name}/skins/outlineNetbook
%{_datadir}/%{name}/skins/outlineNetbook/*

%files skin-traditional
%defattr(-,root,root)
%dir %{_datadir}/%{name}/skins
%dir %{_datadir}/%{name}/skins/traditional
%{_datadir}/%{name}/skins/traditional/*

%files skin-nCut
%defattr(-,root,root)
%dir %{_datadir}/%{name}/skins/nCut
%{_datadir}/%{name}/skins/nCut/*

%files skin-Collusion
%defattr(-,root,root)
%{_datadir}/%{name}/skins/Collusion*

%changelog
* Fri Mar  4 2011 reddwarf@opensuse.org
- Add patch to fix mp4v2 availability check
* Wed Jan  6 2010 toni@links2linux.de
- update to 1.7.2
- reenabled m4a support
- This bugfix release addresses a number of issues that were discovered
  in 1.7.1, and is a recommended upgrade for all users
  Some of the changes include:
  Improved saving of ordered playlists
  Fixed MIDI support on OS X
  Optimize latency settings. This should improve compatibility with certain soundcards/APIs.
  Improved stability and error handling when loading certain songs.
* Sun Oct 25 2009 toni@links2linux.de
- update to 1.7.1
- This release incorporates many major improvements, hugely improved MIDI
  controller support, better vinyl control support, savable cue points, and many
  performance improvements and bugfixes.
- disabled cmetrics and m4a (won't compile)
* Sat Oct  4 2008 toni@links2linux.de
- update to 1.6.1
- removed skin sub-package (skin-Natt)
* Fri Aug  8 2008 toni@links2linux.de
- update to 1.6.0
- enabled shoutcast and iPod support
* Sat Jul 19 2008 toni@links2linux.de
- update to 1.6.0beta4
- added new skin sub-package (skin-Natt)
* Sat May 31 2008 toni@links2linux.de
- update to 1.6.0beta3
* Sun Feb 10 2008 toni@links2linux.de
- update to 1.6.0beta2
* Sat Sep  8 2007 toni@links2linux.de
- openSUSE-10.3 build, corrected BuildRequires
* Wed Mar  7 2007 toni@links2linux.de
- added -lusb in build.definition (is NOT using pkg-config!)
* Sun Mar  4 2007 toni@links2linux.de
- update to 1.5.0.1
- replaced portaudio18 with portaudio
- added libdjconsole support
* Tue Jan  2 2007 toni@links2linux.de
- build SuSE-10.2, corrected BuildRequires
* Thu Nov 30 2006 toni@links2linux.de
- update to 1.5.0beta2
- added debug_package
* Fri Sep 29 2006 toni@links2linux.de
- update to 1.5.0 (cvs 29.09.2006)
- adjusted BuildRequires
* Sun Sep 17 2006 toni@links2linux.de
- build for packman
* Thu Sep  7 2006 oc2pus@arcor.de 1.5.0-0.oc2pus.cvs20060907
- update to 1.5.0 (cvs 07.09.2006)
* Thu Aug 24 2006 oc2pus@arcor.de 1.5.0-0.oc2pus.cvs20060824
- update to 1.5.0 (cvs 24.08.2006)
* Mon Aug 14 2006 oc2pus@arcor.de 1.5.0-0.oc2pus.cvs20060814
- update to 1.5.0 (cvs 14.08.2006)
* Thu Aug 10 2006 oc2pus@arcor.de 1.5.0-0.oc2pus.cvs20060810
- update to 1.5.0 (cvs 10.08.2006)
* Wed May 31 2006 oc2pus@arcor.de 1.5.0-0.oc2pus.cvs20060531
- update to 1.5.0 (cvs 31.05.2006)
* Sat May 20 2006 oc2pus@arcor.de 1.5.0-0.oc2pus.cvs20060520
- update to 1.5.0 (cvs 20.05.2006)
* Sun Apr 23 2006 oc2pus@arcor.de 1.5.0beta1-0.oc2pus.1
- update to 1.5.0beta1
- patched to use package soundtouch=1.3
- patched to use package portaudio18
- repacked without soundtouch and portaudio18* sources
- sub-packages for skins (hercules, outlineClose, outline, traditional)
  - changed menu-entry
* Wed Mar 29 2006 oc2pus@arcor.de 1.5.0-0.oc2pus.cvs20060329
- update to 1.5.0 (cvs 29.03.2006)
* Fri Feb 24 2006 oc2pus@arcor.de 1.5.0-0.oc2pus.cvs20060224
- update to 1.5.0 (cvs 24.02.2006)
- added --enable-python
* Sat Jan 28 2006 oc2pus@arcor.de 1.5.0-0.oc2pus.cvs20060128
- update to 1.5.0 (cvs 28.01.2006)
- patched to use package soundtouch=1.3
- patched to use package portaudio18
- sub-packages for skins (hercules, outlineClose, outline, traditional)
* Tue Jan  3 2006 oc2pus@arcor.de 1.4.2-0.oc2pus.1
- initial release of rpm
- repacked as tar.bz2
